#define BLYNK_PRINT Serial

#include <WiFi.h> //for ESP32
//#include <ESP8266WiFi.h> //for ESP8266 
#include <Blynk.h>
#include <BlynkSimpleEsp32.h> //for ESP32
//#include <BlynkSimpleESP8266.h> //for ESP8266 

//Libraries for brownout detector disabling
//Uncomment if you can't fix "Brownout detector was triggered." error
//#include "soc/soc.h"
//#include "soc/rtc_cntl_reg.h"

//Authorization token from the Blynk app, one for each device
char auth1[] = "Guce1s09zYzmblayiAPZsPGf2vr8EXI5";
char auth2[] = "kuDtTLMbu7scPwOHJjGft8Y4Uzu2QZch";

char ssid[] = "xxx"; //wifi ssid
char pass[] = "xxx"; //wifi password

//define pins for touch sensors
const int touchPin = 32;
const int touchPin2 = 33;
const int touchPin3 = 27;
const int touchPin4 = 14;
const int touchPin5 = 12;
const int touchPin6 = 4;

//define pins for LEDs for touch control:
const int ledPin = 23;
const int ledPin2 = 22;
const int ledPin3 = 21;
const int ledPin4 = 25;
const int ledPin5 = 16;
const int ledPin6 = 2;

// change the threshold value according to your setup
const int threshold = 50;
// variables for storing the touch pin value
int touchValue;
int touchValue2;
int touchValue3;
int touchValue4;
int touchValue5;
int touchValue6;

int val;

//Initiate bridge widget on virtual ports of controller ESP
WidgetBridge bridge1(V1);
WidgetBridge bridge2(V2);
WidgetBridge bridge3(V3);
WidgetBridge bridge4(V4);
WidgetBridge bridge5(V5);

BLYNK_CONNECTED() {
  // Place the authorization token of controlled ESP
  bridge1.setAuthToken(auth2);
  bridge2.setAuthToken(auth2);
  bridge3.setAuthToken(auth2);
  bridge4.setAuthToken(auth2);
  bridge5.setAuthToken(auth2);
}

void setup()
{
  //disable brownout detector if you can't fix "Brownout detector was triggered." error
  //WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0); 
  
  Blynk.begin(auth1, ssid, pass);
  Serial.begin(115200);
  pinMode (ledPin, OUTPUT);
  pinMode (ledPin2, OUTPUT);
  pinMode (ledPin3, OUTPUT);
  pinMode (ledPin4, OUTPUT);
  pinMode (ledPin5, OUTPUT);
}

void loop()
{
  Blynk.run();
  //1st TOUCH BUTTON
  //read the state of the pushbutton value:
  touchValue = touchRead(touchPin);
  Serial.print(touchValue);
  // check if the touchValue is below the threshold
  // if it is, set ledPin to HIGH
  if (touchValue < threshold) {
    // turn LED on
    digitalWrite(ledPin, HIGH);
    Serial.println(" - LED on");
    bridge1.virtualWrite(V1, LOW);

    Serial.print("val");
    Serial.println(" HIGH");
    Blynk.virtualWrite(V1, 1); //Writing to Blynk app if you want to read V1 value in the app

  }
  else {
    // turn LED off
    digitalWrite(ledPin, LOW);
    Serial.println(" - LED off");
    bridge1.virtualWrite(V1, HIGH);
    Blynk.virtualWrite(V1, 0);
    Serial.print("val");
    Serial.println(" LOW");
  }

  //2nd TOUCH BUTTON
  //read the state of the pushbutton value:
  touchValue2 = touchRead(touchPin2);
  Serial.print(touchValue2);
  // check if the touchValue is below the threshold
  // if it is, set ledPin to HIGH
  if (touchValue2 < threshold) {
    // turn LED on
    digitalWrite(ledPin2, HIGH);
    Serial.println(" - LED on");
    bridge2.virtualWrite(V2, LOW);

    Serial.print("val");
    Serial.println(" HIGH");
    Blynk.virtualWrite(V2, 1);


  }
  else {
    // turn LED off
    digitalWrite(ledPin2, LOW);
    Serial.println(" - LED off");
    bridge2.virtualWrite(V2, HIGH);
    Blynk.virtualWrite(V1, 0);
    Serial.print("val");
    Serial.println(" LOW");
  }

  //3rd TOUCH BUTTON
  //read the state of the pushbutton value:
  touchValue3 = touchRead(touchPin3);
  Serial.print(touchValue3);
  // check if the touchValue is below the threshold
  // if it is, set ledPin to HIGH
  if (touchValue3 < threshold) {
    // turn LED on
    digitalWrite(ledPin3, HIGH);
    Serial.println(" - LED on");
    bridge3.virtualWrite(V3, LOW);

    Serial.print("val");
    Serial.println(" HIGH");
    Blynk.virtualWrite(V3, 1);

  }
  else {
    // turn LED off
    digitalWrite(ledPin3, LOW);
    Serial.println(" - LED off");
    bridge3.virtualWrite(V3, HIGH);
    Serial.print("val");
    Serial.println(" LOW");
  }

  //4th TOUCH BUTTON
  // read the state of the pushbutton value:
  touchValue4 = touchRead(touchPin4);
  Serial.print(touchValue4);
  // check if the touchValue is below the threshold
  // if it is, set ledPin to HIGH
  if (touchValue4 < threshold) {
    // turn LED on
    digitalWrite(ledPin4, HIGH);
    Serial.println(" - LED on");
    bridge4.virtualWrite(V4, LOW);

    Serial.print("val");
    Serial.println(" HIGH");
    Blynk.virtualWrite(V4, 1);

  }
  else {
    // turn LED off
    digitalWrite(ledPin4, LOW);
    Serial.println(" - LED off");
    bridge4.virtualWrite(V4, HIGH);

    Serial.print("val");
    Serial.println(" LOW");
  }

  //5th TOUCH BUTTON
  // read the state of the pushbutton value:
  touchValue5 = touchRead(touchPin5);
  Serial.print(touchValue5);
  // check if the touchValue is below the threshold
  // if it is, set ledPin to HIGH
  if (touchValue5 < threshold) {
    // turn LED on
    digitalWrite(ledPin5, HIGH);
    Serial.println(" - LED on");
    bridge5.virtualWrite(V5, LOW);

    Serial.print("val");
    Serial.println(" HIGH");
    Blynk.virtualWrite(V5, 1);

  }
  else {
    // turn LED off
    digitalWrite(ledPin5, LOW);
    Serial.println(" - LED off");
    bridge5.virtualWrite(V5, HIGH);

    Serial.print("val");
    Serial.println(" LOW");
  }
  }
